<html>
<head>
<title>OgreStringInterface.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreStringInterface.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreStringInterface_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __StringInterface_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __StringInterface_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="group__General.html#ga4b8cfe4e77d7d21264a6497c06ed924a">00046</a>     <span class="keyword">enum</span> <a class="code" href="group__General.html#ga4b8cfe4e77d7d21264a6497c06ed924a" title="List of parameter types available.">ParameterType</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa7b72a218a6d93dfbcb77e208eaa3feeb">00048</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa7b72a218a6d93dfbcb77e208eaa3feeb">PT_BOOL</a>,
<a name="l00049"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa6346202346c62e0d276c03eb2f258b16">00049</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa6346202346c62e0d276c03eb2f258b16">PT_REAL</a>,
<a name="l00050"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa6a6d06f6d2147d82b892bee309ff466f">00050</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa6a6d06f6d2147d82b892bee309ff466f">PT_INT</a>,
<a name="l00051"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa960735d7150a41f8c25be3e5d459e5ef">00051</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa960735d7150a41f8c25be3e5d459e5ef">PT_UNSIGNED_INT</a>,
<a name="l00052"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aac1ae17fd22246104d7a7794fcf89e1e1">00052</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aac1ae17fd22246104d7a7794fcf89e1e1">PT_SHORT</a>,
<a name="l00053"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aaca32cf2526bd9f0ec645331b9a1093c1">00053</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aaca32cf2526bd9f0ec645331b9a1093c1">PT_UNSIGNED_SHORT</a>,
<a name="l00054"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa663563417c2b019e268ba62dc4b1c587">00054</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa663563417c2b019e268ba62dc4b1c587">PT_LONG</a>,
<a name="l00055"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa08dbf5d4856777b3dd0dfd7f6d82cd46">00055</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa08dbf5d4856777b3dd0dfd7f6d82cd46">PT_UNSIGNED_LONG</a>,
<a name="l00056"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa631b8a9e92ad1186744a5fa9521b08dc">00056</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa631b8a9e92ad1186744a5fa9521b08dc">PT_STRING</a>,
<a name="l00057"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aad1f53213a85c2b5518e8b974cbbbea76">00057</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aad1f53213a85c2b5518e8b974cbbbea76">PT_VECTOR3</a>,
<a name="l00058"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aada60f8ff24cfcc03772b69968f3aa30f">00058</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aada60f8ff24cfcc03772b69968f3aa30f">PT_MATRIX3</a>,
<a name="l00059"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa9cde1dc36b3e39a8a4e7a2b9bba6d78d">00059</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa9cde1dc36b3e39a8a4e7a2b9bba6d78d">PT_MATRIX4</a>,
<a name="l00060"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa2971f5bea77e8de65d015df46f67733c">00060</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa2971f5bea77e8de65d015df46f67733c">PT_QUATERNION</a>,
<a name="l00061"></a><a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa70b475c72e98912203dc005ef4fd9ffb">00061</a>         <a class="code" href="group__General.html#gga4b8cfe4e77d7d21264a6497c06ed924aa70b475c72e98912203dc005ef4fd9ffb">PT_COLOURVALUE</a>
<a name="l00062"></a>00062     };
<a name="l00063"></a>00063 
<a name="l00065"></a><a class="code" href="classOgre_1_1ParameterDef.html">00065</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection.">ParameterDef</a>
<a name="l00066"></a>00066     {
<a name="l00067"></a>00067     <span class="keyword">public</span>:
<a name="l00068"></a><a class="code" href="classOgre_1_1ParameterDef.html#ab22036d8dcec3fe262e88316e55d9a13">00068</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ParameterDef.html#ab22036d8dcec3fe262e88316e55d9a13">name</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1ParameterDef.html#ae96c017b7f2f644978e2bfd9769b55c2">00069</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ParameterDef.html#ae96c017b7f2f644978e2bfd9769b55c2">description</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1ParameterDef.html#a5f5634c1ecf86d49da2cccdd97641c6a">00070</a>         <a class="code" href="group__General.html#ga4b8cfe4e77d7d21264a6497c06ed924a" title="List of parameter types available.">ParameterType</a> <a class="code" href="classOgre_1_1ParameterDef.html#a5f5634c1ecf86d49da2cccdd97641c6a">paramType</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1ParameterDef.html#a0070696ef2e47e06585ca37ad1223836">00071</a>         <a class="code" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection.">ParameterDef</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newDescription, <a class="code" href="group__General.html#ga4b8cfe4e77d7d21264a6497c06ed924a" title="List of parameter types available.">ParameterType</a> newType)
<a name="l00072"></a>00072             : name(newName), description(newDescription), paramType(newType) {}
<a name="l00073"></a>00073     };
<a name="l00074"></a><a class="code" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">00074</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ParameterDef&gt;::type</a> <a class="code" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">ParameterList</a>;
<a name="l00075"></a>00075 
<a name="l00077"></a><a class="code" href="classOgre_1_1ParamCommand.html">00077</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00078"></a>00078     {
<a name="l00079"></a>00079     <span class="keyword">public</span>:
<a name="l00080"></a>00080         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span> = 0;
<a name="l00081"></a>00081         <span class="keyword">virtual</span> <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val) = 0;
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classOgre_1_1ParamCommand.html#a44288c733303c12a4cb30f483ee006ee">00083</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ParamCommand.html#a44288c733303c12a4cb30f483ee006ee">~ParamCommand</a>() { }
<a name="l00084"></a>00084     };
<a name="l00085"></a><a class="code" href="group__General.html#ga2bce134286f461b9f474618eb0e249b9">00085</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ParamCommand* &gt;::type</a> <a class="code" href="group__General.html#ga2bce134286f461b9f474618eb0e249b9">ParamCommandMap</a>;
<a name="l00086"></a>00086 
<a name="l00088"></a><a class="code" href="classOgre_1_1ParamDictionary.html">00088</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>
<a name="l00089"></a>00089     {
<a name="l00090"></a><a class="code" href="classOgre_1_1ParamDictionary.html#af1037345f6c7a90f967a44cb1eb6dadc">00090</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a>;
<a name="l00091"></a>00091     <span class="keyword">protected</span>:
<a name="l00093"></a><a class="code" href="classOgre_1_1ParamDictionary.html#a37e4ea1d0c014e743b815b6a829f5a75">00093</a>         <a class="code" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">ParameterList</a> <a class="code" href="classOgre_1_1ParamDictionary.html#a37e4ea1d0c014e743b815b6a829f5a75" title="Definitions of parameters.">mParamDefs</a>;
<a name="l00094"></a>00094 
<a name="l00096"></a><a class="code" href="classOgre_1_1ParamDictionary.html#a374491774db59af87966f14795737996">00096</a>         <a class="code" href="group__General.html#ga2bce134286f461b9f474618eb0e249b9">ParamCommandMap</a> <a class="code" href="classOgre_1_1ParamDictionary.html#a374491774db59af87966f14795737996" title="Command objects to get/set.">mParamCommands</a>;
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="classOgre_1_1ParamDictionary.html#a6b324fb02bdd70f7fdd6566fb634e1dc">00099</a>         <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* getParamCommand(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)
<a name="l00100"></a>00100         {
<a name="l00101"></a>00101             ParamCommandMap::iterator i = mParamCommands.find(name);
<a name="l00102"></a>00102             <span class="keywordflow">if</span> (i != mParamCommands.end())
<a name="l00103"></a>00103             {
<a name="l00104"></a>00104                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00105"></a>00105             }
<a name="l00106"></a>00106             <span class="keywordflow">else</span>
<a name="l00107"></a>00107             {
<a name="l00108"></a>00108                 <span class="keywordflow">return</span> 0;
<a name="l00109"></a>00109             }
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classOgre_1_1ParamDictionary.html#a10d47cfb52e9a32917e5a0965a7b7bb8">00112</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* getParamCommand(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword">        </span>{
<a name="l00114"></a>00114             ParamCommandMap::const_iterator i = mParamCommands.find(name);
<a name="l00115"></a>00115             <span class="keywordflow">if</span> (i != mParamCommands.end())
<a name="l00116"></a>00116             {
<a name="l00117"></a>00117                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00118"></a>00118             }
<a name="l00119"></a>00119             <span class="keywordflow">else</span>
<a name="l00120"></a>00120             {
<a name="l00121"></a>00121                 <span class="keywordflow">return</span> 0;
<a name="l00122"></a>00122             }
<a name="l00123"></a>00123         }
<a name="l00124"></a>00124     <span class="keyword">public</span>:
<a name="l00125"></a><a class="code" href="classOgre_1_1ParamDictionary.html#af3f46fdeacdb40c4dc234cd3540cd701">00125</a>         <a class="code" href="classOgre_1_1ParamDictionary.html#af3f46fdeacdb40c4dc234cd3540cd701">ParamDictionary</a>()  {}
<a name="l00132"></a><a class="code" href="classOgre_1_1ParamDictionary.html#a411fa9cc6ca47ea388307fdd7841f547">00132</a>         <span class="keywordtype">void</span> addParameter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection.">ParameterDef</a>&amp; paramDef, <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* paramCmd)
<a name="l00133"></a>00133         {
<a name="l00134"></a>00134             mParamDefs.push_back(paramDef);
<a name="l00135"></a>00135             mParamCommands[paramDef.<a class="code" href="classOgre_1_1ParameterDef.html#ab22036d8dcec3fe262e88316e55d9a13">name</a>] = paramCmd;
<a name="l00136"></a>00136         }
<a name="l00142"></a><a class="code" href="classOgre_1_1ParamDictionary.html#ab0f6c3fd225dc9d3a8a2c4ff6ef6ffda">00142</a>         <span class="keyword">const</span> <a class="code" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">ParameterList</a>&amp; getParameters(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">        </span>{
<a name="l00144"></a>00144             <span class="keywordflow">return</span> mParamDefs;
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     };
<a name="l00150"></a><a class="code" href="group__General.html#gadb243c5b21d57e9c053b067801f47780">00150</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;String, ParamDictionary&gt;::type</a> <a class="code" href="group__General.html#gadb243c5b21d57e9c053b067801f47780">ParamDictionaryMap</a>;
<a name="l00151"></a>00151     
<a name="l00161"></a><a class="code" href="classOgre_1_1StringInterface.html">00161</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a> 
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163     <span class="keyword">private</span>:
<a name="l00164"></a>00164         <a class="code" href="OgrePrerequisites_8h.html#ac853de57688aefaec88f75cd9e0ac388">OGRE_STATIC_MUTEX</a>( msDictionaryMutex )
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         
<a name="l00167"></a><a class="code" href="classOgre_1_1StringInterface.html#a5e08eb863343f9c60f6ef9344a48075b">00167</a>         static <a class="code" href="group__General.html#gadb243c5b21d57e9c053b067801f47780">ParamDictionaryMap</a> msDictionary;
<a name="l00168"></a>00168 
<a name="l00170"></a><a class="code" href="classOgre_1_1StringInterface.html#abaa2b2c02f22cff7a65ba43b4daea538">00170</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mParamDictName;
<a name="l00171"></a><a class="code" href="classOgre_1_1StringInterface.html#a3f3117095c1bff9d46177279d3fb79ea">00171</a>         <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* mParamDict;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     protected:
<a name="l00184"></a><a class="code" href="classOgre_1_1StringInterface.html#a681773443d95aea05a486c5d22c15bd1">00184</a>         <span class="keywordtype">bool</span> createParamDictionary(const <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; className)
<a name="l00185"></a>00185         {
<a name="l00186"></a>00186             <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>( msDictionaryMutex )
<a name="l00187"></a>00187 
<a name="l00188"></a>00188             ParamDictionaryMap::iterator it = msDictionary.find(className);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190             <span class="keywordflow">if</span> ( it == msDictionary.end() )
<a name="l00191"></a>00191             {
<a name="l00192"></a>00192                 mParamDict = &amp;msDictionary.insert( std::make_pair( className, <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>() ) ).first-&gt;second;
<a name="l00193"></a>00193                 mParamDictName = className;
<a name="l00194"></a>00194                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00195"></a>00195             }
<a name="l00196"></a>00196             <span class="keywordflow">else</span>
<a name="l00197"></a>00197             {
<a name="l00198"></a>00198                 mParamDict = &amp;it-&gt;second;
<a name="l00199"></a>00199                 mParamDictName = className;
<a name="l00200"></a>00200                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00201"></a>00201             }
<a name="l00202"></a>00202         }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204     <span class="keyword">public</span>:
<a name="l00205"></a><a class="code" href="classOgre_1_1StringInterface.html#ad57e8c6f0793dde7d1b479361e55e419">00205</a>         <a class="code" href="classOgre_1_1StringInterface.html#ad57e8c6f0793dde7d1b479361e55e419">StringInterface</a>() : mParamDict(NULL) { }
<a name="l00206"></a>00206 
<a name="l00208"></a><a class="code" href="classOgre_1_1StringInterface.html#aa86a8941e57b203088797a4b28da8c4d">00208</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StringInterface.html#aa86a8941e57b203088797a4b28da8c4d" title="Virtual destructor, see Effective C++.">~StringInterface</a>() {}
<a name="l00209"></a>00209 
<a name="l00217"></a><a class="code" href="classOgre_1_1StringInterface.html#ae3e13925bde11db245f6c9bbf5031a93">00217</a>         <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* getParamDictionary(<span class="keywordtype">void</span>)
<a name="l00218"></a>00218         {
<a name="l00219"></a>00219             <span class="keywordflow">return</span> mParamDict;
<a name="l00220"></a>00220         }
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="classOgre_1_1StringInterface.html#a3bfa7791753a155b222dfb2706e5218c">00222</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* getParamDictionary(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00223"></a>00223 <span class="keyword">        </span>{
<a name="l00224"></a>00224             <span class="keywordflow">return</span> mParamDict;
<a name="l00225"></a>00225         }
<a name="l00226"></a>00226 
<a name="l00232"></a>00232         <span class="keyword">const</span> <a class="code" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">ParameterList</a>&amp; getParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00233"></a>00233 
<a name="l00248"></a>00248         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> setParameter(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; value);
<a name="l00258"></a>00258         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setParameterList(<span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>&amp; paramList);
<a name="l00270"></a><a class="code" href="classOgre_1_1StringInterface.html#a57397ce47f649e66c5654da05207df0b">00270</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getParameter(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)<span class="keyword"> const</span>
<a name="l00271"></a>00271 <span class="keyword">        </span>{
<a name="l00272"></a>00272             <span class="comment">// Get dictionary</span>
<a name="l00273"></a>00273             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* dict = getParamDictionary();
<a name="l00274"></a>00274 
<a name="l00275"></a>00275             <span class="keywordflow">if</span> (dict)
<a name="l00276"></a>00276             {
<a name="l00277"></a>00277                 <span class="comment">// Look up command object</span>
<a name="l00278"></a>00278                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* cmd = dict-&gt;<a class="code" href="classOgre_1_1ParamDictionary.html#a6b324fb02bdd70f7fdd6566fb634e1dc" title="Retrieves the parameter command object for a named parameter.">getParamCommand</a>(name);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280                 <span class="keywordflow">if</span> (cmd)
<a name="l00281"></a>00281                 {
<a name="l00282"></a>00282                     <span class="keywordflow">return</span> cmd-&gt;<a class="code" href="classOgre_1_1ParamCommand.html#ae47ea550693403baebbcde11c59e074f">doGet</a>(<span class="keyword">this</span>);
<a name="l00283"></a>00283                 }
<a name="l00284"></a>00284             }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286             <span class="comment">// Fallback</span>
<a name="l00287"></a>00287             <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span>;
<a name="l00288"></a>00288         }
<a name="l00301"></a><a class="code" href="classOgre_1_1StringInterface.html#a702af78cbc4869e64c369fb11c4f1eb5">00301</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyParametersTo(<a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a>* dest)<span class="keyword"> const</span>
<a name="l00302"></a>00302 <span class="keyword">        </span>{
<a name="l00303"></a>00303             <span class="comment">// Get dictionary</span>
<a name="l00304"></a>00304             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* dict = getParamDictionary();
<a name="l00305"></a>00305 
<a name="l00306"></a>00306             <span class="keywordflow">if</span> (dict)
<a name="l00307"></a>00307             {
<a name="l00308"></a>00308                 <span class="comment">// Iterate through own parameters</span>
<a name="l00309"></a>00309                 ParameterList::const_iterator i;
<a name="l00310"></a>00310             
<a name="l00311"></a>00311                 <span class="keywordflow">for</span> (i = dict-&gt;<a class="code" href="classOgre_1_1ParamDictionary.html#a37e4ea1d0c014e743b815b6a829f5a75" title="Definitions of parameters.">mParamDefs</a>.begin(); 
<a name="l00312"></a>00312                 i != dict-&gt;<a class="code" href="classOgre_1_1ParamDictionary.html#a37e4ea1d0c014e743b815b6a829f5a75" title="Definitions of parameters.">mParamDefs</a>.end(); ++i)
<a name="l00313"></a>00313                 {
<a name="l00314"></a>00314                     dest-&gt;<a class="code" href="classOgre_1_1StringInterface.html#ace884b65b722ead9b920b9abf27bf815" title="Generic parameter setting method.">setParameter</a>(i-&gt;name, getParameter(i-&gt;name));
<a name="l00315"></a>00315                 }
<a name="l00316"></a>00316             }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319         }
<a name="l00320"></a>00320 
<a name="l00324"></a>00324         <span class="keyword">static</span> <span class="keywordtype">void</span> cleanupDictionary () ;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326     };
<a name="l00327"></a>00327 
<a name="l00332"></a>00332 }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
